# Alita
> Alita，战斗天使阿丽塔，原型是《铳梦》中一位不断战斗和自我超越的生化改造少女。

Alita是一套React Native代码转换引擎工具。它对React语法有全新的处理方式，支持在运行时处理React语法，可以用简洁、高效的方式把React Native代码转换成微信小程序代码，并且实现了React Native和微信小程序之间的主要组件对齐。


## 基础
在使用Alita之前，我们希望你能了解一些基础知识。提前了解这些知识，可以在你之后使用Alita的过程中少走很多弯路。

* 路由是一个应用必不可少的部分，Alita提供了简单易用的路由组件`@areslabs/router`。并且只支持转化使用了这个路由的RN应用，[详见](./路由.md)
* 微信小程序动画和RN动画是独立的两套机制，我们封装了`@areslabs/wx-animated`动画库，使用这个动画库的RN应用，可以无损的转化运行在小程序上，[详见](./动画.md)
* 多端融合的开发方式，默认了各端的展示和交互是一样的，但是有时候，对于不同端会有不同的需求，这就需要有平台判断的能力，Alita的平台判断方式，参考了ReactNative的方式。[详见](./平台判断.md)
* 关于Redux的支持，[详见](./支持Redux.md)
* 关于Mobx的支持，[详见](./支持mobx.md)
* 当你的项目只使用了React Native官方组件和API的时候，这个配置文件是可以忽略的，使用系统默认配置就可以，但是当你的React Native应用足够复杂的，就需要使用[配置文件](./配置文件.md)了。

## 注意事项
Alita对React Native应用有一些基本要求和限制，另外Alita本身也会使用一些保留字。 除此以外，微信小程序本身就存在一些限制，比如包大小等。对这些限制，希望你有一个足够的了解，这样在使用Alita的过程中就不会出现莫名其妙的错误。

* 提纲挈领的总结了[要求和限制](./要求与限制.md)
* Alita静态代码编译转化的[限制](./静态限制.md)
* 对出现在组件文件之外的JSX片段的[限制](./外部JSX片段.md)
* 一些尚未实现的组件，主要是平台相关组件，[详见](./未实现组件和API.md)
* 高阶组件的一些[约束](./高阶组件.md)
* 对于以上的这些限制，我们提供了对应的`eslint`[检查工具](./代码检查&Eslint.md)。 这个工具，虽然暂时还不能覆盖100%的情况，不过相比于手动查找，还是可以减少很多工作量。

## 高阶
当你了解了Alita基本知识和限制之后，你也许会在其他一些方面遇到问题。

* Alita使用的是运行时JSX的处理，相比社区现有的方案，对JSX支持更加的完备，详见[一种让小程序支持JSX语法的新思路](./一种让小程序支持JSX语法的新思路.md)
* 本文详细介绍了嵌入式React和小程序在运行阶段的[数据交互方式](./mini-react与小程序的数据交换方式.md)
* 很多时候，我们需要把多个RN模块转化集成到一个小程序包里面，这就需要用到[小程序分包集成](./小程序分包集成.md)
* 当项目足够复杂，使用RN基本组件库/API往往很难满足开发需要，很多团队也会有自己的RN基本组件库，这就需要[自定义组件库扩展](./自定义组件库扩展.md)


## 交流反馈
欢迎交流反馈，一般有以下几种方式：

* Alita的代码已经托管在github，可以在这里给我们提交[issues](https://github.com/areslabs/alita/issues)，我们会第一时间反馈处理。

* 联系

|QQ群|微信公众号|    
|--- |---|
|![](./static/qqgroup.jpg)|![](./static/gzh.jpg)|    
    
       

